*:*********************************************************************
*:
*:        Program: BROWPICK.PRG
*:
*:         System: BROWSE INCREMENTER
*:         Author: Richard A. Druckenmiller
*:      Copyright (c) 1992, Richard A. Druckenmiller
*:  Last modified: 02/17/92     23:51
*:
*:          Calls: SET()              (function  in ?)
*:               : WROWS()            (function  in ?)
*:               : WCOLS()            (function  in ?)
*:               : ALLTRIM()          (function  in ?)
*:               : INKEY()            (function  in ?)
*:               : SUBSTR()           (function  in ?)
*:               : LEN()              (function  in ?)
*:               : CHR()              (function  in ?)
*:
*:      Documented 02/18/92 at 00:20               FoxDoc  version 2.10
*:*********************************************************************
PRIVATE ALL LIKE E_*, V_*

*** SAVE PREVIOUS ENVIRONMENT AND SETUP THIS ONE
IF SET('TALK') = 'ON'
   SET TALK OFF
   E_SAVETALK = 'ON'
ELSE
   E_SAVETALK = 'OFF'
ENDIF
E_SAVEBELL = SET('BELL')
SET BELL OFF

*** INIT. MEMVARS
T = ''

*** DEFINE WINDOWS TO USE AND ACTIVATE
DEFINE WINDOW OUTER FROM 1,0 TO 15,40 SHADOW ZOOM DOUBLE COLOR SCHEME 10
ACTIVATE WINDOW OUTER
DEFINE WINDOW INNER IN WINDOW OUTER FROM 1,0 TO WROWS()-1,WCOLS()-1 NOSHADOW

*** POSITION CURSOR TO DISPLAY AND RECEIVE INPUT FROM INKEY() AT UPPER LEFT OF WINDOW
ACTIVATE WINDOW OUTER
@ 0,1 SAY T

GO TOP
BROWSE KEY ALLTRIM(T) NODELETE NOMENU NOMODIFY NOWAIT SAVE ;
   WINDOW INNER NORM
DO WHILE .T.
   
   *** GET USERS INPUT
   I = INKEY(0)
   
   IF I = 27    &&CATCH AN ESCAPE THEN CANCEL PRG
      EXIT
   ENDIF
   
   IF I = 13    &&CATCH AN ENTER (FINAL CHOICE WAS MADE) THEN EXIT
      EXIT
   ENDIF
   
   IF I = 19 OR I = 127    &&CATCH A BACKSPACE OR LEFTARROW
      *** CHOP OFF LAST CHARACTER SINCE BACKSPACE WAS PRESSED
      T = SUBSTR(T,1,LEN(ALLTRIM(T))-1)
   ELSE
      *** ADD NEW CHARACTER TO MEMVAR
      T = T + CHR(I)
   ENDIF
   
   *** ACTIVATE OUTER WINDOW TO DISPLAY AGAIN
   ACTIVATE WINDOW OUTER
   *** TELL USER WHAT THEY'VE ENTERED
   CLEAR
   @ 0,1 SAY T
   
   *** GO TO TOP OF FILE TO RESET FOR BROWSE KEY
   GO TOP
   *** BROWSE LIKE RECORDS IN BROWSE WINDOW
   BROWSE LAST KEY ALLTRIM(T) NOWAIT WINDOW INNER NORM
   
ENDDO

BROWSE LAST

*** RESET AND CLEANUP ENVIRONMENT
RELEASE WINDOW INNER
RELEASE WINDOW OUTER

SET BELL &E_SAVEBELL
SET TALK &E_SAVETALK

RELEASE ALL LIKE E_*, V_*

RETURN
*: EOF: BROWPICK.PRG
